Index: code/trunk/src/orxonox/Level.h
===================================================================
--- code/trunk/src/orxonox/Level.h	(revision 8952)
+++ code/trunk/src/orxonox/Level.h	(revision 9016)
@@ -49,9 +49,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-            inline void setDescription(const std::string& description)
-                { this->description_ = description; }
-            inline const std::string& getDescription() const
-                { return this->description_; }
-
             void playerEntered(PlayerInfo* player);
             void playerLeft(PlayerInfo* player);
@@ -76,5 +71,4 @@
             void networkcallback_applyXMLFile();
 
-            std::string                    description_;
             std::string                    gametype_;
             std::string                    xmlfilename_;
Index: code/trunk/src/orxonox/LevelInfo.cc
===================================================================
--- code/trunk/src/orxonox/LevelInfo.cc	(revision 8952)
+++ code/trunk/src/orxonox/LevelInfo.cc	(revision 9016)
@@ -87,9 +87,10 @@
         {
             LevelInfoItem::possibleTags_s.insert("test");
-            LevelInfoItem::possibleTags_s.insert("singleplayer");
-            LevelInfoItem::possibleTags_s.insert("multiplayer");
             LevelInfoItem::possibleTags_s.insert("showcase");
             LevelInfoItem::possibleTags_s.insert("tutorial");
             LevelInfoItem::possibleTags_s.insert("presentation");
+            LevelInfoItem::possibleTags_s.insert("mission");
+            LevelInfoItem::possibleTags_s.insert("gametype");
+            LevelInfoItem::possibleTags_s.insert("minigame");
         }
     }
@@ -189,4 +190,5 @@
 
         XMLPortParam(LevelInfo, "description", setDescription, getDescription, xmlelement, mode);
+        XMLPortParam(LevelInfo, "screenshot", setScreenshot, getScreenshot, xmlelement, mode);
         XMLPortParam(LevelInfo, "tags", setTags, getTags, xmlelement, mode);
     }
@@ -203,4 +205,5 @@
         LevelInfoItem* info = new LevelInfoItem(this->BaseObject::getName(), this->getXMLFilename());
         info->setDescription(this->getDescription());
+        info->setScreenshot(this->getScreenshot());
         info->setTags(this->getTags());
         return info;
Index: code/trunk/src/orxonox/LevelInfo.h
===================================================================
--- code/trunk/src/orxonox/LevelInfo.h	(revision 8952)
+++ code/trunk/src/orxonox/LevelInfo.h	(revision 9016)
@@ -77,4 +77,15 @@
             */
             inline const std::string& getName(void) const { return this->name_; } // tolua_export
+        
+            /**
+            @brief Set the screenshot of the Level.
+            @param screenshot The screenshot to be set.
+            */
+            inline void setScreenshot(const std::string& screenshot) { this->screenshot_ = std::string(screenshot); }
+            /**
+            @brief Get the screenshot of the Level.
+            @return Returns the screenshot of the Level.
+            */
+            inline const std::string& getScreenshot() const { return this->screenshot_; } // tolua_export
 
             /**
@@ -138,4 +149,5 @@
             std::string name_; //!< The name of the Level.
             std::string description_; //!< The description of the Level.
+            std::string screenshot_; //!< The screenshot of the Level.
             std::set<std::string> tags_; //!< The set of tags the Level is tagged with.
             std::string tagsString_; //!< The comma-seperated string of all the tags the Level is tagged with.
@@ -148,4 +160,5 @@
         - @b name The name of the level.
         - @b description The description of the level.
+        - @b screenshot The screenshot of the level.
         - @b tags A comma-seperated string of tags. Allowed tags are: <em>test</em>, <em>singleplayer</em>, <em>multiplayer</em>, <em>showcase</em>, <em>tutorial</em>, <em>presentation</em>.
 
@@ -155,4 +168,5 @@
             name = "Levelname"lhs->compare(rhs) < 0
             description = "This is just some awesome level."
+            screenshot = "Screenshot.png"
             tags = "test, awesome"
         />
@@ -172,4 +186,15 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Creates a LevelInfo object through XML.
+        
+            /**
+            @brief Set the screenshot of the Level.
+            @param screenshot The screenshot to be set.
+            */
+            inline void setScreenshot(const std::string& screenshot) { this->LevelInfoItem::setScreenshot(screenshot); }
+            /**
+            @brief Get the screenshot of the Level.
+            @return Returns the screenshot of the Level.
+            */
+            inline const std::string& getScreenshot() const { return this->LevelInfoItem::getScreenshot(); }
 
             /**
Index: code/trunk/src/orxonox/controllers/AIController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/AIController.cc	(revision 8952)
+++ code/trunk/src/orxonox/controllers/AIController.cc	(revision 9016)
@@ -59,7 +59,13 @@
         if (this->state_ == FREE)
         {
-
+            
             if (this->formationFlight_)
             {
+
+                //changed order -> searchNewMaster MUSTN'T be called in SLAVE-state (bugfix for internal-error messages at quit)
+                random = rnd(maxrand);
+                if (random < 90 && (((!this->target_) || (random < 50 && this->target_)) && !this->forcedFree()))
+                       this->searchNewMaster();
+
                 // return to Master after being forced free
                 if (this->freedomCount_ == 1)
@@ -68,74 +74,36 @@
                     this->freedomCount_ = 0;
                 }
-
-                random = rnd(maxrand);
-                if (random < 90 && (((!this->target_) || (random < 50 && this->target_)) && !this->forcedFree()))
-                    this->searchNewMaster();
-            }
-
+            }
+
+            this->defaultBehaviour(maxrand);
+
+        }
+
+        if (this->state_ == SLAVE && this->formationMode_ == ATTACK) 
+        {
             // search enemy
             random = rnd(maxrand);
-            if (random < (15 + botlevel_* 20) && (!this->target_))
+            if (random < (botlevel_*100) && (!this->target_))
                 this->searchNewTarget();
 
-            // forget enemy
-            random = rnd(maxrand);
-            if (random < ((1-botlevel_)*6) && (this->target_))
-                this->forgetTarget();
-
             // next enemy
             random = rnd(maxrand);
-            if (random < (botlevel_*20) && (this->target_))
+            if (random < (botlevel_*30) && (this->target_))
                 this->searchNewTarget();
 
-            // fly somewhere
-            random = rnd(maxrand);
-            if (random < 50 && (!this->bHasTargetPosition_ && !this->target_))
-                this->searchRandomTargetPosition();
-
-            // stop flying
-            random = rnd(maxrand);
-            if (random < 10 && (this->bHasTargetPosition_ && !this->target_))
-                this->bHasTargetPosition_ = false;
-
-            // fly somewhere else
-            random = rnd(maxrand);
-            if (random < 30 && (this->bHasTargetPosition_ && !this->target_))
-                this->searchRandomTargetPosition();
-
             // shoot
             random = rnd(maxrand);
-            if (!(this->passive_) && random < (75 + botlevel_*25) && (this->target_ && !this->bShooting_))
+            if (!(this->passive_) && random < (botlevel_*100) && (this->target_ && !this->bShooting_))
                 this->bShooting_ = true;
 
             // stop shooting
             random = rnd(maxrand);
-            if (random < ((1 - botlevel_)*25) && (this->bShooting_))
+            if (random < (1-botlevel_)*50 && (this->bShooting_))
                 this->bShooting_ = false;
 
-            // boost
-            random = rnd(maxrand);
-            if (random < botlevel_*100 )
-                this->boostControl();
-
-            // update Checkpoints
-            /*random = rnd(maxrand);
-            if (this->defaultWaypoint_ && random > (maxrand-10))
-                this->manageWaypoints();
-            else //if(random > maxrand-10) //CHECK USABILITY!!*/
-            if (this->waypoints_.size() == 0 )
-                this->manageWaypoints();
-
-        }
-
-        if (this->state_ == SLAVE)
-        {
-
         }
 
         if (this->state_ == MASTER)
         {
-
-
             this->commandSlaves();
 
@@ -155,9 +123,9 @@
                    this->spinInit();
 
-                // follow a randomly chosen human - a specific Master Action
+                /*// follow a randomly chosen human - a specific Master Action
                 random = rnd(1000.0f);
                 if (random < 1)
                    this->followRandomHumanInit();
-
+*/
                  // lose master status (only if less than 4 slaves in formation)
                 random = rnd(maxrand);
@@ -170,55 +138,6 @@
                     this->searchNewMaster();
 
-                // search enemy
-                random = rnd(maxrand);
-                if (random < (botlevel_)*25 && (!this->target_))
-                    this->searchNewTarget();
-
-                // forget enemy
-                random = rnd(maxrand);
-                if (random < (1-botlevel_)*6 && (this->target_))
-                    this->forgetTarget();
-
-                // next enemy
-                random = rnd(maxrand);
-                if (random < 10 && (this->target_))
-                    this->searchNewTarget();
-
-                // fly somewhere
-                random = rnd(maxrand);
-                if (random < 50 && (!this->bHasTargetPosition_ && !this->target_))
-                    this->searchRandomTargetPosition();
-
-
-                // fly somewhere else
-                random = rnd(maxrand);
-                if (random < 30 && (this->bHasTargetPosition_ && !this->target_))
-                    this->searchRandomTargetPosition();
-
-                // shoot
-                random = rnd(maxrand);
-                if (!(this->passive_) && random < 25*(botlevel_)+1 && (this->target_ && !this->bShooting_))
-                {
-                    this->bShooting_ = true;
-                    this->forceFreeSlaves();
-                }
-
-                // stop shooting
-                random = rnd(maxrand);
-                if (random < ( (1- botlevel_)*25 ) && (this->bShooting_))
-                    this->bShooting_ = false;
-
-                // boost
-                random = rnd(maxrand);
-                if (random < botlevel_*100 )
-                    this->boostControl();
-
-                // update Checkpoints
-                /*random = rnd(maxrand);
-                if (this->defaultWaypoint_ && random > (maxrand-10))
-                    this->manageWaypoints();
-                else //if(random > maxrand-10) //CHECK USABILITY!!*/
-                if (this->waypoints_.size() == 0 )
-                    this->manageWaypoints();
+                this->defaultBehaviour(maxrand);
+
             }
         }
@@ -234,5 +153,5 @@
         float maxrand = 100.0f / ACTION_INTERVAL;
         ControllableEntity* controllable = this->getControllableEntity();
-
+        //DOES: Either move to the waypoint or search for a Point of interest
         if (controllable && this->mode_ == DEFAULT)// bot is ready to move to a target
         {
@@ -256,6 +175,7 @@
             }
         }
-        if(this->mode_ == DEFAULT)
-	    {
+
+        if (this->mode_ == DEFAULT)
+        {
             if (this->state_ == MASTER)
             {
@@ -270,5 +190,5 @@
                             this->aimAtTarget();
                             random = rnd(maxrand);
-                            if(this->botlevel_*100 > random && !this->isCloseAtTarget(20))
+                            if(this->botlevel_*70 > random && !this->isCloseAtTarget(100))
                                 this->follow();  //If a bot is shooting a player, it shouldn't let him go away easily.
                         }
@@ -277,5 +197,4 @@
                     if (this->bHasTargetPosition_)
                         this->moveToTargetPosition();
-
                     this->doFire();
                 }
@@ -290,5 +209,5 @@
             }
 
-            if (this->state_ == SLAVE)
+            if (this->state_ == SLAVE && this->formationMode_ != ATTACK)
             {
                 if (this->bHasTargetPosition_)
@@ -296,5 +215,5 @@
             }
 
-            if (this->state_ == FREE)
+            if (this->state_ == FREE || (this->state_==SLAVE && this->formationMode_ == ATTACK) )
             {
                 if (this->target_)
@@ -302,12 +221,5 @@
                     if (!this->target_->getRadarVisibility()) /* So AI won't shoot invisible Spaceships */
                         this->forgetTarget();
-                    else
-                    {
-                        this->aimAtTarget();
-                        random = rnd(maxrand);
-
-                        if(this->botlevel_*100 > random && !this->isCloseAtTarget(20))
-                            this->follow();//If a bot is shooting a player, it shouldn't let him go away easily.
-                     }
+                    else this->aimAtTarget();
                 }
 
@@ -315,12 +227,13 @@
                     this->moveToTargetPosition();
 
-                this->doFire();
-            }
-        }//END_OF DEFAULT MODE
+                    this->doFire();
+            }
+        }
         else if (this->mode_ == ROCKET)//Rockets do not belong to a group of bots -> bot states are not relevant.
         {   //Vector-implementation: mode_.back() == ROCKET;
             if(controllable)
-            {
-                if(controllable->getRocket())//Check wether the bot is controlling the rocket and if the timeout is over.
+            {//Check wether the bot is controlling the rocket and if the timeout is over.
+                if(controllable->getIdentifier() == ClassByString("Rocket"))
+
                 {
                     this->follow();
@@ -341,4 +254,72 @@
         SUPER(AIController, tick, dt);
     }
+//**********************************************NEW
+    void AIController::defaultBehaviour(float maxrand)
+    {       float random;
+            // search enemy
+            random = rnd(maxrand);
+            if (random < (botlevel_* 100) && (!this->target_))
+                this->searchNewTarget();
+
+            // forget enemy
+            random = rnd(maxrand);
+            if (random < ((1-botlevel_)*20) && (this->target_))
+                this->forgetTarget();
+
+            // next enemy
+            random = rnd(maxrand);
+            if (random < (botlevel_*30) && (this->target_))
+                this->searchNewTarget();
+
+            // fly somewhere
+            random = rnd(maxrand);
+            if (random < 50 && (!this->bHasTargetPosition_ && !this->target_))
+                this->searchRandomTargetPosition();
+
+            // stop flying
+            random = rnd(maxrand);
+            if (random < 10 && (this->bHasTargetPosition_ && !this->target_))
+                this->bHasTargetPosition_ = false;
+
+            // fly somewhere else
+            random = rnd(maxrand);
+            if (random < 30 && (this->bHasTargetPosition_ && !this->target_))
+                this->searchRandomTargetPosition();
+
+            if (this->state_ == MASTER) // master: shoot
+            {
+                random = rnd(maxrand);
+                if (!(this->passive_) && random < (100*botlevel_) && (this->target_ && !this->bShooting_))
+                {
+                    this->bShooting_ = true;
+                    this->forceFreeSlaves();
+                }
+            }
+            else
+            {
+                // shoot
+                random = rnd(maxrand);
+                if (!(this->passive_) && random < (botlevel_*100) && (this->target_ && !this->bShooting_))
+                    this->bShooting_ = true;
+            }
+
+            // stop shooting
+            random = rnd(maxrand);
+            if (random < ((1 - botlevel_)*50) && (this->bShooting_))
+                this->bShooting_ = false;
+
+            // boost
+            random = rnd(maxrand);
+            if (random < botlevel_*50 )
+                this->boostControl();
+
+            // update Checkpoints
+            /*random = rnd(maxrand);
+            if (this->defaultWaypoint_ && random > (maxrand-10))
+                this->manageWaypoints();
+            else //if(random > maxrand-10) //CHECK USABILITY!!*/
+            if (this->waypoints_.size() == 0 )
+                this->manageWaypoints();
+    }
 
 }
Index: code/trunk/src/orxonox/controllers/AIController.h
===================================================================
--- code/trunk/src/orxonox/controllers/AIController.h	(revision 8952)
+++ code/trunk/src/orxonox/controllers/AIController.h	(revision 9016)
@@ -44,13 +44,14 @@
             virtual ~AIController();
 
-            virtual void tick(float dt);
+            virtual void tick(float dt); //<! Carrying out the targets set in action().
 
         protected:
-            virtual void action();
+            virtual void action(); //<! action() is called in regular intervals managing the bot's behaviour ~ setting targets.
+            void defaultBehaviour(float maxrand); //<! Helper function for code reusage. Some concrete commands for a bot.
 
         private:
             static const float ACTION_INTERVAL;
 
-            Timer actionTimer_;
+            Timer actionTimer_; //<! Regularly calls action().
     };
 }
Index: code/trunk/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 8952)
+++ code/trunk/src/orxonox/controllers/ArtificialController.cc	(revision 9016)
@@ -24,25 +24,13 @@
  *   Co-authors:
  *      Dominik Solenicki
- *
+ *      
  */
 
 #include "ArtificialController.h"
-
-#include <vector>
-#include <climits>
-
-#include "util/Math.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
 #include "core/command/ConsoleCommand.h"
-#include "worldentities/ControllableEntity.h"
 #include "worldentities/pawns/Pawn.h"
-#include "worldentities/pawns/TeamBaseMatchBase.h"
 #include "worldentities/pawns/SpaceShip.h"
-#include "gametypes/TeamDeathmatch.h"
-#include "gametypes/Dynamicmatch.h"
-#include "controllers/WaypointPatrolController.h"
-#include "controllers/NewHumanController.h"
-#include "controllers/DroneController.h"
+
 #include "weaponsystem/WeaponMode.h"
 #include "weaponsystem/WeaponPack.h"
@@ -51,51 +39,18 @@
 #include "weaponsystem/WeaponSlot.h"
 
+
 namespace orxonox
 {
-    SetConsoleCommand("ArtificialController", "formationflight",  &ArtificialController::formationflight);
-    SetConsoleCommand("ArtificialController", "masteraction",     &ArtificialController::masteraction);
-    SetConsoleCommand("ArtificialController", "followme",         &ArtificialController::followme);
-    SetConsoleCommand("ArtificialController", "passivebehaviour", &ArtificialController::passivebehaviour);
-    SetConsoleCommand("ArtificialController", "formationsize",    &ArtificialController::formationsize);
     SetConsoleCommand("ArtificialController", "setbotlevel",      &ArtificialController::setAllBotLevel);
 
-    static const unsigned int STANDARD_MAX_FORMATION_SIZE = 7;
-    static const int RADIUS_TO_SEARCH_FOR_MASTERS = 5000;
-    static const int FORMATION_LENGTH =  130;
-    static const int FORMATION_WIDTH =  110;
-    static const int FREEDOM_COUNT = 4; //seconds the slaves in a formation will be set free when master attacks an enemy
-    static const float SPEED_MASTER = 0.6f;
-    static const float ROTATEFACTOR_MASTER = 0.2f;
-    static const float SPEED_FREE = 0.8f;
-    static const float ROTATEFACTOR_FREE = 0.8f;
-
-
-    ArtificialController::ArtificialController(BaseObject* creator) : Controller(creator)
-    {
-        RegisterObject(ArtificialController);
-
-        this->target_ = 0;
-        this->formationFlight_ = false;
-        this->passive_ = false;
-        this->maxFormationSize_ = STANDARD_MAX_FORMATION_SIZE;
-        this->myMaster_ = 0;
-        this->freedomCount_ = 0;
-        this->team_ = -1;
-        this->state_ = FREE;
-        this->specificMasterAction_ = NONE;
-        this->specificMasterActionHoldCount_  = 0;
-        this->bShooting_ = false;
-        this->bHasTargetPosition_ = false;
-        this->speedCounter_ = 0.2f;
-        this->targetPosition_ = Vector3::ZERO;
-
-        this->target_.setCallback(createFunctor(&ArtificialController::targetDied, this));
+    ArtificialController::ArtificialController(BaseObject* creator) : FormationController(creator)
+    {
         this->bSetupWorked = false;
-        this->botlevel_ = 0.2f;
-        this->mode_ = DEFAULT;////Vector-implementation: mode_.push_back(DEFAULT);
+        this->botlevel_ = 0.5f;
         this->timeout_ = 0;
         this->currentWaypoint_ = 0;
         this->setAccuracy(5);
         this->defaultWaypoint_ = NULL;
+        this->mode_ = DEFAULT;//Vector-implementation: mode_.push_back(DEFAULT);
     }
 
@@ -105,211 +60,8 @@
         {//Vector-implementation: mode_.erase(mode_.begin(),mode_.end());
             this->waypoints_.clear();
-            this->removeFromFormation();
             this->weaponModes_.clear();
-            for (ObjectList<ArtificialController>::iterator it = ObjectList<ArtificialController>::begin(); it; ++it)
-            {
-                if (*it != this)
-                {
-                    if (it->myMaster_ == this)
-                    {
-                        orxout(internal_error) << this << " is still master in " << (*it) << endl;
-                        it->myMaster_ = 0;
-                    }
-
-                    while (true)
-                    {
-                        std::vector<ArtificialController*>::iterator it2 = std::find(it->slaves_.begin(), it->slaves_.end(), this);
-                        if (it2 != it->slaves_.end())
-                        {
-                            orxout(internal_error) << this << " is still slave in " << (*it) << endl;
-                            it->slaves_.erase(it2);
-                        }
-                        else
-                            break;
-                    }
-                }
-            }
-        }
-    }
-
-    void ArtificialController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
-    {
-        SUPER(ArtificialController, XMLPort, xmlelement, mode);
-
-        XMLPortParam(ArtificialController, "team", setTeam, getTeam, xmlelement, mode).defaultValues(-1);
-        XMLPortParam(ArtificialController, "formationFlight", setFormationFlight, getFormationFlight, xmlelement, mode).defaultValues(false);
-        XMLPortParam(ArtificialController, "formationSize", setFormationSize, getFormationSize, xmlelement, mode).defaultValues(STANDARD_MAX_FORMATION_SIZE);
-        XMLPortParam(ArtificialController, "passive", setPassive, getPassive, xmlelement, mode).defaultValues(false);
-    }
-
-// Documentation only here to get a faster overview for creating a useful documentation...
-
-    /**
-        @brief Activates / deactivates formationflight behaviour
-        @param form activate formflight if form is true
-    */
-    void ArtificialController::formationflight(const bool form)
-    {
-        for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it; ++it)
-        {
-            Controller* controller = 0;
-
-            if (it->getController())
-                controller = it->getController();
-            else if (it->getXMLController())
-                controller = it->getXMLController();
-
-            if (!controller)
-                continue;
-
-            ArtificialController *aiController = orxonox_cast<ArtificialController*>(controller);
-
-            if (aiController)
-            {
-                aiController->formationFlight_ = form;
-                if (!form)
-                {
-                    aiController->removeFromFormation();
-                }
-            }
-        }
-    }
-
-    /**
-        @brief Get all masters to do a "specific master action"
-        @param action which action to perform (integer, so it can be called with a console command (tmp solution))
-    */
-    void ArtificialController::masteraction(const int action)
-    {
-        for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it; ++it)
-        {
-            Controller* controller = 0;
-
-            if (it->getController())
-                controller = it->getController();
-            else if (it->getXMLController())
-                controller = it->getXMLController();
-
-            if (!controller)
-                continue;
-
-            ArtificialController *aiController = orxonox_cast<ArtificialController*>(controller);
-
-            if(aiController && aiController->state_ == MASTER)
-            {
-                if (action == 1)
-                    aiController->spinInit();
-                if (action == 2)
-                    aiController->turn180Init();
-            }
-        }
-    }
-
-    /**
-        @brief A human player gets followed by its nearest master. Initiated by console command, so far intended for demonstration puproses (possible future pickup).
-    */
-    void ArtificialController::followme()
-    {
-
-        Pawn *humanPawn = NULL;
-        NewHumanController *currentHumanController = NULL;
-        std::vector<ArtificialController*> allMasters;
-
-        for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it; ++it)
-        {
-            Controller* controller = 0;
-
-            if (it->getController())
-                controller = it->getController();
-            else if (it->getXMLController())
-                controller = it->getXMLController();
-
-            if (!controller)
-                continue;
-
-            currentHumanController = orxonox_cast<NewHumanController*>(controller);
-
-            if(currentHumanController) humanPawn = *it;
-
-            ArtificialController *aiController = orxonox_cast<ArtificialController*>(controller);
-
-            if(aiController && aiController->state_ == MASTER)
-                allMasters.push_back(aiController);
-
-        }
-
-        if((humanPawn != NULL) && (allMasters.size() != 0))
-        {
-                float posHuman = humanPawn->getPosition().length();
-                float distance = 0.0f;
-                float minDistance = FLT_MAX;
-                int index = 0;
-                int i = 0;
-
-                for(std::vector<ArtificialController*>::iterator it = allMasters.begin(); it != allMasters.end(); it++, i++)
-                    {
-                        if (!ArtificialController::sameTeam((*it)->getControllableEntity(), humanPawn, (*it)->getGametype())) continue;
-                        distance = posHuman - (*it)->getControllableEntity()->getPosition().length();
-                        if(distance < minDistance) index = i;
-                    }
-                allMasters[index]->followInit(humanPawn);
-            }
-
-    }
-
-    /**
-        @brief Sets shooting behaviour of pawns.
-        @param passive if true, bots won't shoot.
-    */
-    void ArtificialController::passivebehaviour(const bool passive)
-    {
-        for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it; ++it)
-        {
-            Controller* controller = 0;
-
-            if (it->getController())
-                controller = it->getController();
-            else if (it->getXMLController())
-                controller = it->getXMLController();
-
-            if (!controller)
-                continue;
-
-            ArtificialController *aiController = orxonox_cast<ArtificialController*>(controller);
-
-            if(aiController)
-            {
-                aiController->passive_ = passive;
-            }
-        }
-    }
-
-
-    /**
-        @brief Sets maximal formation size
-        @param size maximal formation size.
-    */
-    void ArtificialController::formationsize(const int size)
-    {
-        for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it; ++it)
-        {
-            Controller* controller = 0;
-
-            if (it->getController())
-                controller = it->getController();
-            else if (it->getXMLController())
-                controller = it->getXMLController();
-
-            if (!controller)
-                continue;
-
-            ArtificialController *aiController = orxonox_cast<ArtificialController*>(controller);
-
-            if(aiController)
-            {
-                aiController->maxFormationSize_ = size;
-            }
-        }
-    }
+        }
+    }
+
 
     /**
